>From 90371486a0bbe1f3440de06484056207ff1f83bd Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Jan=20Urba=C5=84ski?= <wulczer@wulczer.org>
Date: Wed, 12 Jan 2011 23:08:15 +0100
Subject: [PATCH 4/4] Add MSVC support for generating files based on errcodes.txt

---
 src/tools/msvc/Solution.pm  |   13 +++++++++++++
 src/tools/msvc/builddoc.bat |    1 +
 2 files changed, 14 insertions(+), 0 deletions(-)

diff --git a/src/tools/msvc/Solution.pm b/src/tools/msvc/Solution.pm
index b737e1e..39c7170 100644
--- a/src/tools/msvc/Solution.pm
+++ b/src/tools/msvc/Solution.pm
@@ -273,6 +273,19 @@ s{PG_VERSION_STR "[^"]+"}{__STRINGIFY(x) #x\n#define __STRINGIFY2(z) __STRINGIFY
         );
     }
 
+    if (IsNewer('src\include\utils\errcodes.h','src\include\utils\errcodes.txt'))
+    {
+        print "Generating errcodes.h...\n";
+        system("perl src\backend\utils\generate-errcodes.pl src\include\utils\errcodes.txt > src\backend\utils\errcodes.h");
+        copyFile('src\backend\utils\errcodes.h','src\include\utils\errcodes.h');
+    }
+
+    if (IsNewer('src\pl\plpgsql\src\plerrcodes.h','src\include\utils\errcodes.txt'))
+    {
+        print "Generating plerrcodes.h...\n";
+        system("perl src\pl\plpgsql\src\generate-plerrcodes.pl src\include\utils\errcodes.txt > src\pl\plpgsql\src\plerrcodes.h");
+    }
+
     if (IsNewer('src\interfaces\libpq\libpq.rc','src\interfaces\libpq\libpq.rc.in'))
     {
         print "Generating libpq.rc...\n";
diff --git a/src/tools/msvc/builddoc.bat b/src/tools/msvc/builddoc.bat
index 81c97ab..c90cfe8 100755
--- a/src/tools/msvc/builddoc.bat
+++ b/src/tools/msvc/builddoc.bat
@@ -32,6 +32,7 @@ SET SGML_CATALOG_FILES=%DOCROOT%\%OPENJADE%\dsssl\catalog;%DOCROOT%\docbook\docb
 perl %DOCROOT%\%DSSSL%\bin\collateindex.pl -f -g -o bookindex.sgml -N
 perl mk_feature_tables.pl YES ..\..\..\src\backend\catalog\sql_feature_packages.txt ..\..\..\src\backend\catalog\sql_features.txt > features-supported.sgml
 perl mk_feature_tables.pl NO ..\..\..\src\backend\catalog\sql_feature_packages.txt ..\..\..\src\backend\catalog\sql_features.txt > features-unsupported.sgml
+perl make-errcodes-table.pl ..\..\..\src\include\utils\errcodes.txt > errcodes-table.sgml
 
 echo Running first build...
 %DOCROOT%\%OPENJADE%\bin\openjade -V draft-mode -wall -wno-unused-param -wno-empty -D . -c %DOCROOT%\%DSSSL%\catalog -d stylesheet.dsl -i output-html -t sgml postgres.sgml 2>&1 | findstr /V "DTDDECL catalog entries are not supported"
-- 
1.7.2.3

